test-lib.sh 25.0 KB
Newer Older
1 2 3 4
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#
5 6 7 8 9 10 11 12 13 14 15 16
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/ .
17

18 19 20 21 22 23
# if --tee was passed, write the output not only to the terminal, but
# additionally to the file test-results/$BASENAME.out, too.
case "$GIT_TEST_TEE_STARTED, $* " in
done,*)
	# do not redirect again
	;;
24
*' --tee '*|*' --va'*)
25 26 27 28 29 30 31 32 33
	mkdir -p test-results
	BASE=test-results/$(basename "$0" .sh)
	(GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
	 echo $? > $BASE.exit) | tee $BASE.out
	test "$(cat $BASE.exit)" = 0
	exit
	;;
esac

34 35 36
# Keep the original TERM for say_color
ORIGINAL_TERM=$TERM

37 38
# For repeatability, reset the environment to known value.
LANG=C
39
LC_ALL=C
40
PAGER=cat
41
TZ=UTC
42 43
TERM=dumb
export LANG LC_ALL PAGER TERM TZ
44
EDITOR=:
45
unset VISUAL
46
unset GIT_EDITOR
47
unset EMAIL
48 49
unset GIT_ALTERNATE_OBJECT_DIRECTORIES
unset GIT_AUTHOR_DATE
50 51
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
52
unset GIT_COMMITTER_DATE
53 54
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
55 56
unset GIT_DIFF_OPTS
unset GIT_DIR
57
unset GIT_WORK_TREE
58 59 60
unset GIT_EXTERNAL_DIFF
unset GIT_INDEX_FILE
unset GIT_OBJECT_DIRECTORY
61
unset GIT_CEILING_DIRECTORIES
62
unset GIT_NOTES_REF
63
unset GIT_NOTES_DISPLAY_REF
64 65
unset GIT_NOTES_REWRITE_REF
unset GIT_NOTES_REWRITE_MODE
66 67 68
unset GIT_REFLOG_ACTION
unset GIT_CHERRY_PICK_HELP
unset GIT_QUIET
69 70
GIT_MERGE_VERBOSITY=5
export GIT_MERGE_VERBOSITY
71 72
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
73
export EDITOR
74

75 76 77 78
# Protect ourselves from common misconfiguration to export
# CDPATH into the environment
unset CDPATH

B
Bert Wesarg 已提交
79 80
unset GREP_OPTIONS

81
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
82 83 84 85 86 87 88 89
	1|2|true)
		echo "* warning: Some tests will not work if GIT_TRACE" \
			"is set as to trace on STDERR ! *"
		echo "* warning: Please set GIT_TRACE to something" \
			"other than 1, 2 or true ! *"
		;;
esac

90 91 92 93 94 95
# Convenience
#
# A regexp to match 5 and 40 hexdigits
_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"

96 97 98 99 100 101
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh
102 103 104 105 106 107 108 109
[ "x$ORIGINAL_TERM" != "xdumb" ] && (
		TERM=$ORIGINAL_TERM &&
		export TERM &&
		[ -t 1 ] &&
		tput bold >/dev/null 2>&1 &&
		tput setaf 1 >/dev/null 2>&1 &&
		tput sgr0 >/dev/null 2>&1
	) &&
110
	color=t
111 112 113 114 115 116

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
117 118
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
119
	-l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
J
Junio C Hamano 已提交
120
		GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
121
	-h|--h|--he|--hel|--help)
122
		help=t; shift ;;
123 124
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
125
	-q|--q|--qu|--qui|--quie|--quiet)
126 127 128
		# Ignore --quiet under a TAP::Harness. Saying how many tests
		# passed without the ok/not ok details is always an error.
		test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
129 130
	--with-dashes)
		with_dashes=t; shift ;;
131
	--no-color)
132
		color=; shift ;;
133
	--va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
134
		valgrind=t; verbose=t; shift ;;
135 136
	--tee)
		shift ;; # was handled already
137 138 139
	--root=*)
		root=$(expr "z$1" : 'z[^=]*=\(.*\)')
		shift ;;
140
	*)
141
		echo "error: unknown test option '$1'" >&2; exit 1 ;;
142 143 144
	esac
done

145 146
if test -n "$color"; then
	say_color () {
147 148 149
		(
		TERM=$ORIGINAL_TERM
		export TERM
150 151 152 153 154
		case "$1" in
			error) tput bold; tput setaf 1;; # bold red
			skip)  tput bold; tput setaf 2;; # bold green
			pass)  tput setaf 2;;            # green
			info)  tput setaf 3;;            # brown
155
			*) test -n "$quiet" && return;;
156 157
		esac
		shift
158
		printf "%s" "$*"
159
		tput sgr0
160
		echo
161
		)
162 163 164
	}
else
	say_color() {
165
		test -z "$1" && test -n "$quiet" && return
166
		shift
167
		echo "$*"
168 169 170 171 172
	}
fi

error () {
	say_color error "error: $*"
173
	GIT_EXIT_OK=t
174 175 176 177 178 179 180
	exit 1
}

say () {
	say_color info "$*"
}

181 182 183 184 185 186 187 188 189
test "${test_description}" != "" ||
error "Test script did not set test_description."

if test "$help" = "t"
then
	echo "$test_description"
	exit 0
fi

190
exec 5>&1
191 192 193 194 195 196 197 198 199
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0
J
Junio C Hamano 已提交
200 201
test_fixed=0
test_broken=0
202
test_success=0
203

204 205
test_external_has_tap=0

206
die () {
207 208 209 210 211 212 213 214
	code=$?
	if test -n "$GIT_EXIT_OK"
	then
		exit $code
	else
		echo >&5 "FATAL: Unexpected exit with code $code"
		exit 1
	fi
215 216
}

217
GIT_EXIT_OK=
218
trap 'die' EXIT
219

220 221 222 223 224 225 226 227
# The semantics of the editor variables are that of invoking
# sh -c "$EDITOR \"$@\"" files ...
#
# If our trash directory contains shell metacharacters, they will be
# interpreted if we just set $EDITOR directly, so do a little dance with
# environment variables to work around this.
#
# In particular, quoting isn't enough, as the path may contain the same quote
228
# that we're using.
229 230 231
test_set_editor () {
	FAKE_EDITOR="$1"
	export FAKE_EDITOR
232 233
	EDITOR='"$FAKE_EDITOR"'
	export EDITOR
234 235
}

236
test_decode_color () {
237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258
	awk '
		function name(n) {
			if (n == 0) return "RESET";
			if (n == 1) return "BOLD";
			if (n == 30) return "BLACK";
			if (n == 31) return "RED";
			if (n == 32) return "GREEN";
			if (n == 33) return "YELLOW";
			if (n == 34) return "BLUE";
			if (n == 35) return "MAGENTA";
			if (n == 36) return "CYAN";
			if (n == 37) return "WHITE";
			if (n == 40) return "BLACK";
			if (n == 41) return "BRED";
			if (n == 42) return "BGREEN";
			if (n == 43) return "BYELLOW";
			if (n == 44) return "BBLUE";
			if (n == 45) return "BMAGENTA";
			if (n == 46) return "BCYAN";
			if (n == 47) return "BWHITE";
		}
		{
259
			while (match($0, /\033\[[0-9;]*m/) != 0) {
260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277
				printf "%s<", substr($0, 1, RSTART-1);
				codes = substr($0, RSTART+2, RLENGTH-3);
				if (length(codes) == 0)
					printf "%s", name(0)
				else {
					n = split(codes, ary, ";");
					sep = "";
					for (i = 1; i <= n; i++) {
						printf "%s%s", sep, name(ary[i]);
						sep = ";"
					}
				}
				printf ">";
				$0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
			}
			print
		}
	'
278 279
}

280 281 282 283
nul_to_q () {
	perl -pe 'y/\000/Q/'
}

284 285 286 287 288 289 290 291
q_to_nul () {
	perl -pe 'y/Q/\000/'
}

q_to_cr () {
	tr Q '\015'
}

J
Jonathan Nieder 已提交
292 293 294 295
q_to_tab () {
	tr Q '\011'
}

296 297 298 299 300 301 302 303
append_cr () {
	sed -e 's/$/Q/' | tr Q '\015'
}

remove_cr () {
	tr '\015' Q | sed -e 's/Q$//'
}

304 305 306 307 308 309 310 311 312 313 314
# In some bourne shell implementations, the "unset" builtin returns
# nonzero status when a variable to be unset was not set in the first
# place.
#
# Use sane_unset when that should not be considered an error.

sane_unset () {
	unset "$@"
	return 0
}

315 316 317
test_tick () {
	if test -z "${test_tick+set}"
	then
J
Junio C Hamano 已提交
318
		test_tick=1112911993
319 320 321
	else
		test_tick=$(($test_tick + 60))
	fi
J
Junio C Hamano 已提交
322 323
	GIT_COMMITTER_DATE="$test_tick -0700"
	GIT_AUTHOR_DATE="$test_tick -0700"
324 325
	export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
}
326

327 328 329 330 331 332 333 334
# Call test_commit with the arguments "<message> [<file> [<contents>]]"
#
# This will commit a file with the given contents and the given commit
# message.  It will also add a tag with <message> as name.
#
# Both <file> and <contents> default to <message>.

test_commit () {
335
	file=${2:-"$1.t"}
336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351
	echo "${3-$1}" > "$file" &&
	git add "$file" &&
	test_tick &&
	git commit -m "$1" &&
	git tag "$1"
}

# Call test_merge with the arguments "<message> <commit>", where <commit>
# can be a tag pointing to the commit-to-merge.

test_merge () {
	test_tick &&
	git merge -m "$1" "$2" &&
	git tag "$1"
}

352 353 354 355 356 357 358 359 360
# This function helps systems where core.filemode=false is set.
# Use it instead of plain 'chmod +x' to set or unset the executable bit
# of a file in the working directory and add it to the index.

test_chmod () {
	chmod "$@" &&
	git update-index --add "--chmod=$@"
}

361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377
# Use test_set_prereq to tell that a particular prerequisite is available.
# The prerequisite can later be checked for in two ways:
#
# - Explicitly using test_have_prereq.
#
# - Implicitly by specifying the prerequisite tag in the calls to
#   test_expect_{success,failure,code}.
#
# The single parameter is the prerequisite tag (a simple word, in all
# capital letters by convention).

test_set_prereq () {
	satisfied="$satisfied$1 "
}
satisfied=" "

test_have_prereq () {
378 379 380 381 382
	# prerequisites can be concatenated with ','
	save_IFS=$IFS
	IFS=,
	set -- $*
	IFS=$save_IFS
383 384 385 386 387

	total_prereq=0
	ok_prereq=0
	missing_prereq=

388 389
	for prerequisite
	do
390
		total_prereq=$(($total_prereq + 1))
391 392
		case $satisfied in
		*" $prerequisite "*)
393 394
			ok_prereq=$(($ok_prereq + 1))
			;;
395
		*)
396 397 398 399 400 401 402
			# Keep a list of missing prerequisites
			if test -z "$missing_prereq"
			then
				missing_prereq=$prerequisite
			else
				missing_prereq="$prerequisite,$missing_prereq"
			fi
403 404
		esac
	done
405 406

	test $total_prereq = $ok_prereq
407 408
}

409 410 411 412 413 414 415 416 417
test_declared_prereq () {
	case ",$test_prereq," in
	*,$1,*)
		return 0
		;;
	esac
	return 1
}

J
Junio C Hamano 已提交
418 419 420 421
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
422
	test_success=$(($test_success + 1))
423
	say_color "" "ok $test_count - $@"
424 425
}

J
Junio C Hamano 已提交
426
test_failure_ () {
427
	test_failure=$(($test_failure + 1))
428
	say_color error "not ok - $test_count $1"
429
	shift
430
	echo "$@" | sed -e 's/^/#	/'
431
	test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
J
Junio C Hamano 已提交
432 433
}

J
Junio C Hamano 已提交
434 435
test_known_broken_ok_ () {
	test_fixed=$(($test_fixed+1))
436
	say_color "" "ok $test_count - $@ # TODO known breakage"
J
Junio C Hamano 已提交
437 438 439 440
}

test_known_broken_failure_ () {
	test_broken=$(($test_broken+1))
441
	say_color skip "not ok $test_count - $@ # TODO known breakage"
J
Junio C Hamano 已提交
442
}
J
Junio C Hamano 已提交
443 444

test_debug () {
445
	test "$debug" = "" || eval "$1"
446 447
}

448
test_run_ () {
449
	test_cleanup=:
450
	eval >&3 2>&4 "$1"
451
	eval_ret=$?
452
	eval >&3 2>&4 "$test_cleanup"
453 454 455
	if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
		echo ""
	fi
456 457 458
	return 0
}

459
test_skip () {
460
	test_count=$(($test_count+1))
461 462 463
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
464
		case $this_test.$test_count in
465 466
		$skp)
			to_skip=t
467
			break
468 469
		esac
	done
470 471
	if test -z "$to_skip" && test -n "$test_prereq" &&
	   ! test_have_prereq "$test_prereq"
472 473 474
	then
		to_skip=t
	fi
475 476
	case "$to_skip" in
	t)
477
		of_prereq=
478
		if test "$missing_prereq" != "$test_prereq"
479
		then
480
			of_prereq=" of $test_prereq"
481 482
		fi

483
		say_color skip >&3 "skipping test: $@"
484
		say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
485 486 487 488 489 490 491 492
		: true
		;;
	*)
		false
		;;
	esac
}

493
test_expect_failure () {
494
	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
495
	test "$#" = 2 ||
496
	error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
497
	export test_prereq
498
	if ! test_skip "$@"
499
	then
J
Junio C Hamano 已提交
500
		say >&3 "checking known breakage: $2"
501
		test_run_ "$2"
J
Junio C Hamano 已提交
502
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
503
		then
J
Junio C Hamano 已提交
504
			test_known_broken_ok_ "$1"
505
		else
506
			test_known_broken_failure_ "$1"
507
		fi
508
	fi
509
	echo >&3 ""
510 511 512
}

test_expect_success () {
513
	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
514
	test "$#" = 2 ||
515
	error "bug in the test script: not 2 or 3 parameters to test-expect-success"
516
	export test_prereq
517
	if ! test_skip "$@"
518
	then
519 520 521 522 523 524 525 526
		say >&3 "expecting success: $2"
		test_run_ "$2"
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
		then
			test_ok_ "$1"
		else
			test_failure_ "$@"
		fi
527
	fi
528
	echo >&3 ""
529 530
}

531 532 533
# test_external runs external test scripts that provide continuous
# test output about their progress, and succeeds/fails on
# zero/non-zero exit code.  It outputs the test output on stdout even
534
# in non-verbose mode, and announces the external script with "# run
535 536 537 538 539
# <n>: ..." before running it.  When providing relative paths, keep in
# mind that all scripts run in "trash directory".
# Usage: test_external description command arguments...
# Example: test_external 'Perl API' perl ../path/to/test.pl
test_external () {
540
	test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
541 542
	test "$#" = 3 ||
	error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
543 544
	descr="$1"
	shift
545
	export test_prereq
546 547 548 549
	if ! test_skip "$descr" "$@"
	then
		# Announce the script to reduce confusion about the
		# test output that follows.
550
		say_color "" "# run $test_count: $descr ($*)"
551 552 553
		# Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
		# to be able to use them in script
		export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
554 555 556 557 558 559
		# Run command; redirect its stderr to &4 as in
		# test_run_, but keep its stdout on our stdout even in
		# non-verbose mode.
		"$@" 2>&4
		if [ "$?" = 0 ]
		then
560 561 562 563 564 565
			if test $test_external_has_tap -eq 0; then
				test_ok_ "$descr"
			else
				say_color "" "# test_external test $descr was ok"
				test_success=$(($test_success + 1))
			fi
566
		else
567 568 569 570 571 572
			if test $test_external_has_tap -eq 0; then
				test_failure_ "$descr" "$@"
			else
				say_color error "# test_external test $descr failed: $@"
				test_failure=$(($test_failure + 1))
			fi
573 574 575 576 577 578 579 580 581 582 583 584 585 586 587
		fi
	fi
}

# Like test_external, but in addition tests that the command generated
# no output on stderr.
test_external_without_stderr () {
	# The temporary file has no (and must have no) security
	# implications.
	tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
	stderr="$tmp/git-external-stderr.$$.tmp"
	test_external "$@" 4> "$stderr"
	[ -f "$stderr" ] || error "Internal error: $stderr disappeared."
	descr="no stderr: $1"
	shift
588
	say >&3 "# expecting no stderr from previous command"
589 590
	if [ ! -s "$stderr" ]; then
		rm "$stderr"
591 592 593 594 595 596 597

		if test $test_external_has_tap -eq 0; then
			test_ok_ "$descr"
		else
			say_color "" "# test_external_without_stderr test $descr was ok"
			test_success=$(($test_success + 1))
		fi
598 599
	else
		if [ "$verbose" = t ]; then
600
			output=`echo; echo "# Stderr is:"; cat "$stderr"`
601 602 603 604 605
		else
			output=
		fi
		# rm first in case test_failure exits.
		rm "$stderr"
606 607 608 609 610 611
		if test $test_external_has_tap -eq 0; then
			test_failure_ "$descr" "$@" "$output"
		else
			say_color error "# test_external_without_stderr test $descr failed: $@: $output"
			test_failure=$(($test_failure + 1))
		fi
612 613 614
	fi
}

615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645
# debugging-friendly alternatives to "test [-f|-d|-e]"
# The commands test the existence or non-existence of $1. $2 can be
# given to provide a more precise diagnosis.
test_path_is_file () {
	if ! [ -f "$1" ]
	then
		echo "File $1 doesn't exist. $*"
		false
	fi
}

test_path_is_dir () {
	if ! [ -d "$1" ]
	then
		echo "Directory $1 doesn't exist. $*"
		false
	fi
}

test_path_is_missing () {
	if [ -e "$1" ]
	then
		echo "Path exists:"
		ls -ld "$1"
		if [ $# -ge 1 ]; then
			echo "$*"
		fi
		false
	fi
}

646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667
# test_line_count checks that a file has the number of lines it
# ought to. For example:
#
#	test_expect_success 'produce exactly one line of output' '
#		do something >output &&
#		test_line_count = 1 output
#	'
#
# is like "test $(wc -l <output) = 1" except that it passes the
# output through when the number of lines is wrong.

test_line_count () {
	if test $# != 3
	then
		error "bug in the test script: not 3 parameters to test_line_count"
	elif ! test $(wc -l <"$3") "$1" "$2"
	then
		echo "test_line_count: line count for $3 !$1 $2"
		cat "$3"
		return 1
	fi
}
668

J
Junio C Hamano 已提交
669 670 671 672 673 674 675 676 677 678 679 680 681 682
# This is not among top-level (test_expect_success | test_expect_failure)
# but is a prefix that can be used in the test script, like:
#
#	test_expect_success 'complain and die' '
#           do something &&
#           do something else &&
#	    test_must_fail git checkout ../outerspace
#	'
#
# Writing this as "! git checkout ../outerspace" is wrong, because
# the failure could be due to a segv.  We want a controlled failure.

test_must_fail () {
	"$@"
683 684 685 686 687 688 689
	exit_code=$?
	if test $exit_code = 0; then
		echo >&2 "test_must_fail: command succeeded: $*"
		return 1
	elif test $exit_code -gt 129 -a $exit_code -le 192; then
		echo >&2 "test_must_fail: died by signal: $*"
		return 1
690 691 692
	elif test $exit_code = 127; then
		echo >&2 "test_must_fail: command not found: $*"
		return 1
693 694
	fi
	return 0
J
Junio C Hamano 已提交
695 696
}

697 698 699 700 701 702 703 704 705 706 707 708 709
# Similar to test_must_fail, but tolerates success, too.  This is
# meant to be used in contexts like:
#
#	test_expect_success 'some command works without configuration' '
#		test_might_fail git config --unset all.configuration &&
#		do something
#	'
#
# Writing "git config --unset all.configuration || :" would be wrong,
# because we want to notice if it fails due to segv.

test_might_fail () {
	"$@"
710 711 712 713
	exit_code=$?
	if test $exit_code -gt 129 -a $exit_code -le 192; then
		echo >&2 "test_might_fail: died by signal: $*"
		return 1
714 715 716
	elif test $exit_code = 127; then
		echo >&2 "test_might_fail: command not found: $*"
		return 1
717 718
	fi
	return 0
719 720
}

721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742
# Similar to test_must_fail and test_might_fail, but check that a
# given command exited with a given exit code. Meant to be used as:
#
#	test_expect_success 'Merge with d/f conflicts' '
#		test_expect_code 1 git merge "merge msg" B master
#	'

test_expect_code () {
	want_code=$1
	shift
	"$@"
	exit_code=$?
	if test $exit_code = $want_code
	then
		echo >&2 "test_expect_code: command exited with $exit_code: $*"
		return 0
	else
		echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
		return 1
	fi
}

743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759
# test_cmp is a helper function to compare actual and expected output.
# You can use it like:
#
#	test_expect_success 'foo works' '
#		echo expected >expected &&
#		foo >actual &&
#		test_cmp expected actual
#	'
#
# This could be written as either "cmp" or "diff -u", but:
# - cmp's output is not nearly as easy to read as diff -u
# - not all diff versions understand "-u"

test_cmp() {
	$GIT_TEST_CMP "$@"
}

760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780
# This function can be used to schedule some commands to be run
# unconditionally at the end of the test to restore sanity:
#
#	test_expect_success 'test core.capslock' '
#		git config core.capslock true &&
#		test_when_finished "git config --unset core.capslock" &&
#		hello world
#	'
#
# That would be roughly equivalent to
#
#	test_expect_success 'test core.capslock' '
#		git config core.capslock true &&
#		hello world
#		git config --unset core.capslock
#	'
#
# except that the greeting and config --unset must both succeed for
# the test to pass.

test_when_finished () {
781 782
	test_cleanup="{ $*
		} && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
783 784
}

785
# Most tests can use the created repository, but some may need to create more.
786 787 788 789 790
# Usage: test_create_repo <directory>
test_create_repo () {
	test "$#" = 1 ||
	error "bug in the test script: not 1 parameter to test-create-repo"
	repo="$1"
791
	mkdir -p "$repo"
792 793 794 795 796 797
	(
		cd "$repo" || error "Cannot setup test environment"
		"$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
		error "cannot run git init -- have you built things yet?"
		mv .git/hooks .git/hooks-disabled
	) || exit
798
}
J
Junio C Hamano 已提交
799

800
test_done () {
801
	GIT_EXIT_OK=t
802

803 804 805 806 807 808 809 810 811 812 813 814
	if test -z "$HARNESS_ACTIVE"; then
		test_results_dir="$TEST_DIRECTORY/test-results"
		mkdir -p "$test_results_dir"
		test_results_path="$test_results_dir/${0%.sh}-$$.counts"

		echo "total $test_count" >> $test_results_path
		echo "success $test_success" >> $test_results_path
		echo "fixed $test_fixed" >> $test_results_path
		echo "broken $test_broken" >> $test_results_path
		echo "failed $test_failure" >> $test_results_path
		echo "" >> $test_results_path
	fi
J
Junio C Hamano 已提交
815 816 817

	if test "$test_fixed" != 0
	then
818
		say_color pass "# fixed $test_fixed known breakage(s)"
J
Junio C Hamano 已提交
819 820 821
	fi
	if test "$test_broken" != 0
	then
822
		say_color error "# still have $test_broken known breakage(s)"
823 824 825
		msg="remaining $(($test_count-$test_broken)) test(s)"
	else
		msg="$test_count test(s)"
J
Junio C Hamano 已提交
826
	fi
827
	case "$test_failure" in
828
	0)
829 830 831
		# Maybe print SKIP message
		[ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"

832 833 834 835
		if test $test_external_has_tap -eq 0; then
			say_color pass "# passed all $msg"
			say "1..$test_count$skip_all"
		fi
J
Johannes Schindelin 已提交
836 837 838 839 840

		test -d "$remove_trash" &&
		cd "$(dirname "$remove_trash")" &&
		rm -rf "$(basename "$remove_trash")"

841 842 843
		exit 0 ;;

	*)
844 845 846 847
		if test $test_external_has_tap -eq 0; then
			say_color error "# failed $test_failure among $msg"
			say "1..$test_count"
		fi
848

849 850 851 852 853 854
		exit 1 ;;

	esac
}

# Test the binaries we have just built.  The tests are kept in
855
# t/ subdirectory and are run in 'trash directory' subdirectory.
856 857 858 859 860 861 862
if test -z "$TEST_DIRECTORY"
then
	# We allow tests to override this, in case they want to run tests
	# outside of t/, e.g. for running tests on the test library
	# itself.
	TEST_DIRECTORY=$(pwd)
fi
863 864
GIT_BUILD_DIR="$TEST_DIRECTORY"/..

865
if test -n "$valgrind"
866 867 868 869 870 871 872 873 874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890
then
	make_symlink () {
		test -h "$2" &&
		test "$1" = "$(readlink "$2")" || {
			# be super paranoid
			if mkdir "$2".lock
			then
				rm -f "$2" &&
				ln -s "$1" "$2" &&
				rm -r "$2".lock
			else
				while test -d "$2".lock
				do
					say "Waiting for lock on $2."
					sleep 1
				done
			fi
		}
	}

	make_valgrind_symlink () {
		# handle only executables
		test -x "$1" || return

		base=$(basename "$1")
891
		symlink_target=$GIT_BUILD_DIR/$base
892 893 894 895 896 897 898
		# do not override scripts
		if test -x "$symlink_target" &&
		    test ! -d "$symlink_target" &&
		    test "#!" != "$(head -c 2 < "$symlink_target")"
		then
			symlink_target=../valgrind.sh
		fi
899 900 901 902
		case "$base" in
		*.sh|*.perl)
			symlink_target=../unprocessed-script
		esac
903 904 905 906 907 908 909
		# create the link, or replace it if it is out of date
		make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
	}

	# override all git executables in TEST_DIRECTORY/..
	GIT_VALGRIND=$TEST_DIRECTORY/valgrind
	mkdir -p "$GIT_VALGRIND"/bin
910
	for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
911 912 913
	do
		make_valgrind_symlink $file
	done
914 915 916 917 918 919 920 921 922 923 924
	OLDIFS=$IFS
	IFS=:
	for path in $PATH
	do
		ls "$path"/git-* 2> /dev/null |
		while read file
		do
			make_valgrind_symlink "$file"
		done
	done
	IFS=$OLDIFS
925 926 927
	PATH=$GIT_VALGRIND/bin:$PATH
	GIT_EXEC_PATH=$GIT_VALGRIND/bin
	export GIT_VALGRIND
928 929 930
elif test -n "$GIT_TEST_INSTALLED" ; then
	GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
	error "Cannot run git from $GIT_TEST_INSTALLED."
931
	PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
932 933
	GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
else # normal case, use ../bin-wrappers only unless $with_dashes:
934
	git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
935 936 937 938 939 940 941
	if ! test -x "$git_bin_dir/git" ; then
		if test -z "$with_dashes" ; then
			say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
		fi
		with_dashes=t
	fi
	PATH="$git_bin_dir:$PATH"
942
	GIT_EXEC_PATH=$GIT_BUILD_DIR
943
	if test -n "$with_dashes" ; then
944
		PATH="$GIT_BUILD_DIR:$PATH"
945
	fi
946
fi
947
GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
J
Jeff King 已提交
948 949
unset GIT_CONFIG
GIT_CONFIG_NOSYSTEM=1
950
GIT_ATTR_NOSYSTEM=1
951
export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
952

953
. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
J
Jeff King 已提交
954

955 956 957 958 959 960 961 962 963 964
if test -z "$GIT_TEST_CMP"
then
	if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
	then
		GIT_TEST_CMP="$DIFF -c"
	else
		GIT_TEST_CMP="$DIFF -u"
	fi
fi

965
GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
966
export GITPERLLIB
967
test -d "$GIT_BUILD_DIR"/templates/blt || {
968 969
	error "You haven't built things yet, have you?"
}
970

J
Jeff King 已提交
971
if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
972
then
973
	GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
974
	export GITPYTHONLIB
975
	test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
976 977 978 979
		error "You haven't built git_remote_helpers yet, have you?"
	}
fi

980
if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
E
Eric Wong 已提交
981 982 983 984 985
	echo >&2 'You need to build test-chmtime:'
	echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
	exit 1
fi

986
# Test repository
J
Johannes Schindelin 已提交
987
test="trash directory.$(basename "$0" .sh)"
988 989 990 991 992
test -n "$root" && test="$root/$test"
case "$test" in
/*) TRASH_DIRECTORY="$test" ;;
 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
esac
993
test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
994
rm -fr "$test" || {
995
	GIT_EXIT_OK=t
996 997 998 999
	echo >&5 "FATAL: Cannot prepare test area"
	exit 1
}

1000
test_create_repo "$test"
1001 1002 1003
# Use -P to resolve symlinks in our working directory so that the cwd
# in subprocesses like git equals our $PWD (for pathname comparisons).
cd -P "$test" || exit 1
1004

1005 1006 1007
HOME=$(pwd)
export HOME

1008 1009
this_test=${0##*/}
this_test=${this_test%%-*}
1010 1011
for skp in $GIT_SKIP_TESTS
do
1012 1013
	case "$this_test" in
	$skp)
1014
		say_color skip >&3 "skipping test $this_test altogether"
1015
		skip_all="skip all tests in $this_test"
1016 1017 1018
		test_done
	esac
done
1019

1020 1021 1022 1023 1024 1025 1026 1027 1028 1029 1030 1031 1032 1033 1034
# Provide an implementation of the 'yes' utility
yes () {
	if test $# = 0
	then
		y=y
	else
		y="$*"
	fi

	while echo "$y"
	do
		:
	done
}

1035 1036 1037 1038 1039 1040 1041 1042 1043 1044
# Fix some commands on Windows
case $(uname -s) in
*MINGW*)
	# Windows has its own (incompatible) sort and find
	sort () {
		/usr/bin/sort "$@"
	}
	find () {
		/usr/bin/find "$@"
	}
1045 1046 1047
	sum () {
		md5sum "$@"
	}
1048 1049 1050 1051
	# git sees Windows-style pwd
	pwd () {
		builtin pwd -W
	}
1052
	# no POSIX permissions
1053
	# backslashes in pathspec are converted to '/'
1054
	# exec does not inherit the PID
1055
	test_set_prereq MINGW
1056 1057 1058 1059 1060 1061 1062
	test_set_prereq SED_STRIPS_CR
	;;
*CYGWIN*)
	test_set_prereq POSIXPERM
	test_set_prereq EXECKEEPSPID
	test_set_prereq NOT_MINGW
	test_set_prereq SED_STRIPS_CR
1063 1064 1065
	;;
*)
	test_set_prereq POSIXPERM
1066
	test_set_prereq BSLASHPSPEC
1067
	test_set_prereq EXECKEEPSPID
P
Pat Thoyts 已提交
1068
	test_set_prereq NOT_MINGW
1069 1070
	;;
esac
1071

1072
test -z "$NO_PERL" && test_set_prereq PERL
1073
test -z "$NO_PYTHON" && test_set_prereq PYTHON
1074

1075 1076 1077
# test whether the filesystem supports symbolic links
ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
rm -f y
1078 1079 1080 1081

# When the tests are run as root, permission tests will report that
# things are writable when they shouldn't be.
test -w / || test_set_prereq SANITY